## mingw-w64-gnuradio-3.10.11.0-11.src.tar.zst

=== docs/CMakeLists.txt ===
# Copyright 2011 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
find_package(Doxygen)
find_package(MathJax2)

########################################################################
# Register components
########################################################################
include(GrComponent)
gr_register_component("doxygen" ENABLE_DOXYGEN DOXYGEN_FOUND)
gr_register_component("man-pages" ENABLE_MANPAGES)

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_DOXYGEN)
    add_subdirectory(doxygen)
endif(ENABLE_DOXYGEN)

if(ENABLE_MANPAGES)
    add_subdirectory(man)
endif(ENABLE_MANPAGES)

=== gnuradio-runtime/CMakeLists.txt ===
# Copyright 2013,2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup dependencies
########################################################################
include(GrBoost)
include(GrPython)

find_package(MPLIB)

########################################################################
# Setup compatibility checks and defines
########################################################################
include(${CMAKE_CURRENT_SOURCE_DIR}/ConfigChecks.cmake)
gr_check_linux_sched_avail()

########################################################################
# Find spdlog
########################################################################
find_package(spdlog CONFIG)

########################################################################
# Register component
########################################################################
include(GrComponent)
gr_register_component(
    "gnuradio-runtime"
    ENABLE_GNURADIO_RUNTIME
    Boost_FOUND
    PYTHONINTERP_FOUND
    MPLIB_FOUND
    spdlog_FOUND
    Volk_FOUND)

get_filename_component(GNURADIO_RUNTIME_PYTHONPATH ${PROJECT_SOURCE_DIR}/python ABSOLUTE)
########################################################################
# Setup precompiled header pseudo-component
########################################################################
if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.16.0")
    set(GR_CMAKE_HAS_PCH ${CMAKE_VERSION})
endif()

gr_register_component("common-precompiled-headers" ENABLE_COMMON_PCH
                      ENABLE_GNURADIO_RUNTIME GR_CMAKE_HAS_PCH)

if(ENABLE_COMMON_PCH)
    add_library(common-precompiled-headers STATIC
                ${CMAKE_CURRENT_SOURCE_DIR}/lib/dummy.cc)
    target_include_directories(
        common-precompiled-headers
        PUBLIC $<INSTALL_INTERFACE:include>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>)

    if(MSVC)
        target_compile_definitions(
            common-precompiled-headers
            PUBLIC # disables stupidity and enables std::min and std::max
                   -DNOMINMAX)
    endif(MSVC)

    target_precompile_headers(
        common-precompiled-headers
        PUBLIC
        $<$<COMPILE_LANGUAGE:CXX>:$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/gnuradio/top_block.h>>
    )
    target_link_libraries(common-precompiled-headers PUBLIC spdlog::spdlog)
endif()

########################################################################
# Register controlport component
########################################################################

gr_register_component("gr-ctrlport" ENABLE_GR_CTRLPORT Boost_FOUND
                      ENABLE_GNURADIO_RUNTIME)

# find thrift quietly to determine whether it should be enabled by default
find_package(THRIFT ${GR_THRIFT_MIN_VERSION} QUIET)
option(ENABLE_CTRLPORT_THRIFT "Enable ControlPort Thrift support" ${THRIFT_FOUND})

if(ENABLE_CTRLPORT_THRIFT)
    # ensure we have thrift, loudly, since it is enabled
    find_package(THRIFT ${GR_THRIFT_MIN_VERSION} REQUIRED)
endif()

########################################################################
# Begin conditional configuration
########################################################################
if(ENABLE_GNURADIO_RUNTIME)

    get_filename_component(GR_RUNTIME_PYTHONPATH ${CMAKE_CURRENT_SOURCE_DIR}/python
                           ABSOLUTE)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-runtime.conf.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.conf @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.conf
            DESTINATION ${GR_PREFSDIR})

    set(PC_ADD_CFLAGS ${MPLIB_PC_ADD_CFLAGS})

    ########################################################################
    # Add subdirectories
    ########################################################################
    add_subdirectory(include)
    add_subdirectory(lib)
    add_subdirectory(apps)
    if(ENABLE_PYTHON)
        add_subdirectory(python)
        if(ENABLE_EXAMPLES)
            add_subdirectory(examples)
        endif(ENABLE_EXAMPLES)
    endif(ENABLE_PYTHON)

    ########################################################################
    # Create Pkg Config File
    ########################################################################
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-runtime.pc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.pc @ONLY)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-runtime.pc
            DESTINATION ${GR_LIBRARY_DIR}/pkgconfig)

endif(ENABLE_GNURADIO_RUNTIME)

=== gr-blocks/lib/CMakeLists.txt ===
# Copyright 2012-2014,2018-2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Setup compatibility checks and defines
########################################################################
include(GrMiscUtils)
gr_check_hdr_n_def(io.h HAVE_IO_H)

if(SNDFILE_FOUND)
    if(NOT PC_SNDFILE_VERSION VERSION_LESS 1.0.29)
        add_definitions(-DHAVE_SF_FORMAT_OPUS)
    endif()
endif()

########################################################################
# Setup library
########################################################################
set(BLOCKS_SOURCES
    abs_blk_impl.cc
    add_blk_impl.cc
    add_const_v_impl.cc
    and_blk_impl.cc
    and_const_impl.cc
    argmax_impl.cc
    blockinterleaver_xx_impl.cc
    blockinterleaving.cc
    burst_to_stream_impl.cc
    correctiq_auto_impl.cc
    correctiq_impl.cc
    correctiq_man_impl.cc
    correctiq_swapiq_impl.cc
    divide_impl.cc
    integrate_impl.cc
    max_blk_impl.cc
    min_blk_impl.cc
    moving_average_impl.cc
    multiply_const_impl.cc
    multiply_impl.cc
    mute_impl.cc
    not_blk_impl.cc
    packed_to_unpacked_impl.cc
    peak_detector_impl.cc
    phase_shift_impl.cc
    probe_signal_impl.cc
    probe_signal_v_impl.cc
    sample_and_hold_impl.cc
    selector_impl.cc
    sub_impl.cc
    tsb_vector_sink_impl.cc
    unpacked_to_packed_impl.cc
    vector_insert_impl.cc
    vector_sink_impl.cc
    vector_source_impl.cc
    xor_blk_impl.cc
    or_blk_impl.cc
    control_loop.cc
    count_bits.cc
    file_sink_base.cc
    pack_k_bits.cc
    unpack_k_bits.cc
    add_const_bb_impl.cc
    add_const_ss_impl.cc
    add_const_ii_impl.cc
    add_const_ff_impl.cc
    add_const_cc_impl.cc
    annotator_1to1_impl.cc
    annotator_alltoall_impl.cc
    annotator_raw_impl.cc
    burst_tagger_impl.cc
    char_to_float_impl.cc
    char_to_short_impl.cc
    check_lfsr_32k_s_impl.cc
    complex_to_interleaved_char_impl.cc
    complex_to_interleaved_short_impl.cc
    complex_to_float_impl.cc
    complex_to_magphase_impl.cc
    complex_to_real_impl.cc
    complex_to_imag_impl.cc
    complex_to_mag_impl.cc
    complex_to_mag_squared_impl.cc
    complex_to_arg_impl.cc
    conjugate_cc_impl.cc
    copy_impl.cc
    deinterleave_impl.cc
    delay_impl.cc
    endian_swap_impl.cc
    exponentiate_const_cci_impl.cc
    file_descriptor_sink_impl.cc
    file_descriptor_source_impl.cc
    file_sink_impl.cc
    file_source_impl.cc
    file_meta_sink_impl.cc
    file_meta_source_impl.cc
    float_to_char_impl.cc
    float_to_complex_impl.cc
    magphase_to_complex_impl.cc
    float_array_to_int.cc
    float_to_int_impl.cc
    float_to_short_impl.cc
    float_array_to_uchar.cc
    float_to_uchar_impl.cc
    head_impl.cc
    host_buffer_copy_impl.cc
    int_to_float_impl.cc
    interleave_impl.cc
    interleaved_short_to_complex_impl.cc
    interleaved_char_to_complex_impl.cc
    keep_m_in_n_impl.cc
    keep_one_in_n_impl.cc
    lfsr_32k_source_s_impl.cc
    message_debug_impl.cc
    message_strobe_impl.cc
    message_strobe_random_impl.cc
    multiply_conjugate_cc_impl.cc
    multiply_const_v_impl.cc
    multiply_matrix_impl.cc
    multiply_by_tag_value_cc_impl.cc
    nlog10_ff_impl.cc
    nop_impl.cc
    null_sink_impl.cc
    null_source_impl.cc
    pack_k_bits_bb_impl.cc
    patterned_interleaver_impl.cc
    tag_debug_impl.cc
    peak_detector2_fb_impl.cc
    plateau_detector_fb_impl.cc
    probe_rate_impl.cc
    regenerate_bb_impl.cc
    repack_bits_bb_impl.cc
    repeat_impl.cc
    rms_cf_impl.cc
    rms_ff_impl.cc
    rotator_cc_impl.cc
    short_to_char_impl.cc
    short_to_float_impl.cc
    skiphead_impl.cc
    stream_demux_impl.cc
    stream_mux_impl.cc
    stream_to_streams_impl.cc
    stream_to_tagged_stream_impl.cc
    stream_to_vector_impl.cc
    streams_to_stream_impl.cc
    streams_to_vector_impl.cc
    stretch_ff_impl.cc
    tag_share_impl.cc
    tagged_file_sink_impl.cc
    tagged_stream_multiply_length_impl.cc
    tags_strobe_impl.cc
    test_tag_variable_rate_ff_impl.cc
    threshold_ff_impl.cc
    throttle_impl.cc
    transcendental_impl.cc
    tag_gate_impl.cc
    tagged_stream_align_impl.cc
    tagged_stream_mux_impl.cc
    uchar_array_to_float.cc
    uchar_to_float_impl.cc
    unpack_k_bits_bb_impl.cc
    vco_f_impl.cc
    vco_c_impl.cc
    vector_map_impl.cc
    vector_to_stream_impl.cc
    vector_to_streams_impl.cc)

if(SNDFILE_FOUND)
    set(BLOCKS_SOURCES ${BLOCKS_SOURCES} wavfile_sink_impl.cc wavfile_source_impl.cc)
endif()

add_library(gnuradio-blocks ${BLOCKS_SOURCES})

target_link_libraries(gnuradio-blocks PUBLIC gnuradio-runtime Volk::volk)

if(SNDFILE_FOUND)
    target_link_libraries(gnuradio-blocks PRIVATE sndfile::sndfile)
endif()

if(ENABLE_COMMON_PCH)
    target_link_libraries(gnuradio-blocks PRIVATE common-precompiled-headers)
endif()

target_include_directories(
    gnuradio-blocks PUBLIC $<INSTALL_INTERFACE:include>
                           $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>)

set_source_files_properties(file_source_impl.cc PROPERTIES SKIP_PRECOMPILE_HEADERS ON
                                                           COMPILE_FLAGS
                                                           -D_FILE_OFFSET_BITS=64)

if(ENABLE_GR_CTRLPORT)
    target_sources(
        gnuradio-blocks
        PRIVATE ctrlport_probe_c_impl.cc ctrlport_probe2_c_impl.cc
                ctrlport_probe2_f_impl.cc ctrlport_probe2_s_impl.cc
                ctrlport_probe2_i_impl.cc ctrlport_probe2_b_impl.cc)
endif()

#Add Windows DLL resource file if using MSVC
if(MSVC)
    include(${PROJECT_SOURCE_DIR}/cmake/Modules/GrVersion.cmake)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gnuradio-blocks.rc.in
                   ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-blocks.rc @ONLY)

    target_sources(gnuradio-blocks PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/gnuradio-blocks.rc)
endif(MSVC)

if(BUILD_SHARED_LIBS)
    gr_library_foo(gnuradio-blocks)
endif()

########################################################################
# QA C++ Code for gr-blocks
########################################################################
if(ENABLE_TESTING)
    include(GrTest)

    list(
        APPEND
        test_gr_blocks_sources
        qa_block_tags.cc
        qa_gr_block.cc
        qa_gr_flowgraph.cc
        qa_gr_hier_block2.cc
        qa_gr_hier_block2_derived.cc
        qa_gr_top_block.cc
        qa_rotator.cc
        qa_set_msg_handler.cc)
    list(APPEND GR_TEST_TARGET_DEPS gnuradio-blocks)

    foreach(qa_file ${test_gr_blocks_sources})
        gr_add_cpp_test("blocks_${qa_file}" ${CMAKE_CURRENT_SOURCE_DIR}/${qa_file})
        if(NOT CMAKE_CROSSCOMPILING)
            set_tests_properties("blocks_${qa_file}" PROPERTIES TIMEOUT 30)
        endif(NOT CMAKE_CROSSCOMPILING)
    endforeach(qa_file)

endif(ENABLE_TESTING)

=== gr-vocoder/examples/CMakeLists.txt ===
# Copyright 2011,2016,2019 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# Install Examples
########################################################################
include(GrPython)

GR_PYTHON_INSTALL(
    PROGRAMS
    alaw_audio_loopback.py
    cvsd_audio_loopback.py
    g721_audio_loopback.py
    g723_24_audio_loopback.py
    g723_40_audio_loopback.py
    ulaw_audio_loopback.py
    DESTINATION ${GR_PKG_VOCODER_EXAMPLES_DIR}
)
if(LIBCODEC2_FOUND)
  GR_PYTHON_INSTALL(
    PROGRAMS
    codec2_audio_loopback.py
    DESTINATION ${GR_PKG_VOCODER_EXAMPLES_DIR}
    )
  install(
    FILES
    grfreedv.grc
    loopback-codec2.grc
    DESTINATION ${GR_PKG_VOCODER_EXAMPLES_DIR}
    )
endif(LIBCODEC2_FOUND)
if(LIBGSM_FOUND)
  GR_PYTHON_INSTALL(
    PROGRAMS
    gsm_audio_loopback.py
    DESTINATION ${GR_PKG_VOCODER_EXAMPLES_DIR}
    )
  install(
    FILES
    loopback-gsmfr.grc
    DESTINATION ${GR_PKG_VOCODER_EXAMPLES_DIR}
    )
endif(LIBGSM_FOUND)

=== gr-vocoder/grc/CMakeLists.txt ===
# Copyright 2011,2016 Free Software Foundation, Inc.
#
# This file is part of GNU Radio
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

install(FILES
    vocoder_alaw_decode_bs.block.yml
    vocoder_alaw_encode_sb.block.yml
    vocoder_cvsd_decode_bs.block.yml
    vocoder_cvsd_decode.block.yml
    vocoder_cvsd_encode_sb.block.yml
    vocoder_cvsd_encode.block.yml
    vocoder_g721_decode_bs.block.yml
    vocoder_g721_encode_sb.block.yml
    vocoder_g723_24_decode_bs.block.yml
    vocoder_g723_24_encode_sb.block.yml
    vocoder_g723_40_decode_bs.block.yml
    vocoder_g723_40_encode_sb.block.yml
    vocoder_ulaw_decode_bs.block.yml
    vocoder_ulaw_encode_sb.block.yml
    vocoder.tree.yml
    DESTINATION ${GRC_BLOCKS_DIR}
)

if(LIBCODEC2_FOUND)
  install(FILES
    vocoder_codec2_decode_ps.block.yml
    vocoder_codec2_encode_sp.block.yml
    DESTINATION ${GRC_BLOCKS_DIR}
    )
endif(LIBCODEC2_FOUND)

if(LIBCODEC2_HAS_FREEDV_API)
  install(FILES
    vocoder_freedv_rx_ss.block.yml
    vocoder_freedv_tx_ss.block.yml
    DESTINATION ${GRC_BLOCKS_DIR}
    COMPONENT "vocoder_python"
    )
endif(LIBCODEC2_HAS_FREEDV_API)

if(LIBGSM_FOUND)
  install(FILES
    vocoder_gsm_fr_decode_ps.block.yml
    vocoder_gsm_fr_encode_sp.block.yml
    DESTINATION ${GRC_BLOCKS_DIR}
    )
endif(LIBGSM_FOUND)

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=gnuradio
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.10.11.0
pkgrel=11
pkgdesc="General purpose DSP and SDR toolkit (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://gnuradio.org/'
msys2_repository_url="https://github.com/gnuradio/gnuradio"
msys2_references=(
  'archlinux: gnuradio'
)
license=(spdx:GPL-3.0-or-later)
depends=("${MINGW_PACKAGE_PREFIX}-codec2"
  "${MINGW_PACKAGE_PREFIX}-boost-libs"
  "${MINGW_PACKAGE_PREFIX}-gcc-libs"
  "${MINGW_PACKAGE_PREFIX}-gmp"
  "${MINGW_PACKAGE_PREFIX}-gsl"
  "${MINGW_PACKAGE_PREFIX}-gsm"
  "${MINGW_PACKAGE_PREFIX}-gtk3"
  "${MINGW_PACKAGE_PREFIX}-libad9361-iio"
  "${MINGW_PACKAGE_PREFIX}-libiio"
  "${MINGW_PACKAGE_PREFIX}-libuhd" 
  "${MINGW_PACKAGE_PREFIX}-libunwind"
  "${MINGW_PACKAGE_PREFIX}-fftw"
  "${MINGW_PACKAGE_PREFIX}-mathjax2"
  "${MINGW_PACKAGE_PREFIX}-volk"
  "${MINGW_PACKAGE_PREFIX}-python-click"
  "${MINGW_PACKAGE_PREFIX}-python-click-plugins"
  "${MINGW_PACKAGE_PREFIX}-python-gobject"
  "${MINGW_PACKAGE_PREFIX}-python-cairo"
  "${MINGW_PACKAGE_PREFIX}-python-jsonschema"
  "${MINGW_PACKAGE_PREFIX}-python-mako"
  "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
  "${MINGW_PACKAGE_PREFIX}-python-numpy"
  "${MINGW_PACKAGE_PREFIX}-python-pygccxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyaml" 
  "${MINGW_PACKAGE_PREFIX}-python-pyzmq"
  "${MINGW_PACKAGE_PREFIX}-python-scipy"
  "${MINGW_PACKAGE_PREFIX}-python-qtpy"
  "${MINGW_PACKAGE_PREFIX}-python-pyqt5"
  "${MINGW_PACKAGE_PREFIX}-python-pyqtgraph"
  "${MINGW_PACKAGE_PREFIX}-python-lxml"
  "${MINGW_PACKAGE_PREFIX}-python-pyopengl"
  "${MINGW_PACKAGE_PREFIX}-qt5-base"
  "${MINGW_PACKAGE_PREFIX}-angleproject"
  "${MINGW_PACKAGE_PREFIX}-qwt-qt5"
  "${MINGW_PACKAGE_PREFIX}-SDL"
  "${MINGW_PACKAGE_PREFIX}-soapysdr"
  "${MINGW_PACKAGE_PREFIX}-portaudio"
  "${MINGW_PACKAGE_PREFIX}-libsndfile"
  "${MINGW_PACKAGE_PREFIX}-spdlog"
  "${MINGW_PACKAGE_PREFIX}-fmt"
  "${MINGW_PACKAGE_PREFIX}-zeromq")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cppzmq"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-python-packaging"
             "${MINGW_PACKAGE_PREFIX}-python-pip")
checkdepends=("${MINGW_PACKAGE_PREFIX}-python-setuptools"
              "${MINGW_PACKAGE_PREFIX}-python-pytest")
optdepends=("${MINGW_PACKAGE_PREFIX}-soapyrtlsdr: install to use RTL-SDR devices with gnuradio")
options=('!strip')
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/gnuradio/gnuradio/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz.asc"
        0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch
        https://github.com/gnuradio/gnuradio/commit/16ef847807553d65b80666b238643794b0b93d71.patch
        https://github.com/gnuradio/gnuradio/commit/111a4ff8b868791dae74d8cdf8c1e0684840f51a.patch
        numpy-2.0.patch
        gnuradio-blocks-and-examples-path.hook.in
        gnuradio-blocks-and-examples-path.script.in
        LICENSE.txt)
validpgpkeys=(
  'B90DDFAC56989BF62262EB812987C77CBB8ED9B2'  # GNU Radio Project (Admin) <admin@gnuradio.org>
  'D74F9F146E7F755783583158B343B2BA293E5174'  # Marcus Müller (GNU Radio Maintainer) <mmueller@gnuradio.org>
  '723EC3A2B90533C6B93DFBC8ED797743F7951435'  # GNU Radio (Software Signing Key) <info@gnuradio.org>
)
sha256sums=('9ca658e6c4af9cfe144770757b34ab0edd23f6dcfaa6c5c46a7546233e5ecd29'
            'SKIP'
            'aa9c79f6ab923c566f57d90117fa7e82549c26230538ffb3a2b1c0246fc31c19'
            '05f60071b421d9bd30cc4744dbaa035581c77dd03e8da94c12083fa619be3868'
            '844d5157489fcd25467b98cbb48c4a52cc95eba41dc32a1c39c48fa75e21be19'
            'e3a2d9f63318b56f87829d224232724d9c815b46c6c7086ac3c5b6ae8980bc7b'
            'b2f014a69b32afcb207e4d2e8e163fc04968594d7d4c3184b9ea5c8cf2a29329'
            'caa9a6cc253d508abcd01545f26b46df0d708d24f69b7dc59183d631872721ed'
            '86dc4bc79c9fa4d5dc3ae5558441d5bb8b8736403e70997cf9ae8f671ab5d0ca')
 
prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Patch number 0001 is credited to Ryan Volz <ryan.volz@gmail.com> and licensed under the 
  # BSD-3-Clause license
  patch -Np1 -i "${srcdir}/0001-cmake-Install-python-wrapper-exe-for-scripts-on-Wind.patch"
  patch -Np1 -i "${srcdir}/16ef847807553d65b80666b238643794b0b93d71.patch"
  patch -Np1 -i "${srcdir}/111a4ff8b868791dae74d8cdf8c1e0684840f51a.patch"
  patch -Np1 -i "${srcdir}/numpy-2.0.patch"
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # FIXME remove -DENABLE_CTRLPORT_THRIFT=OFF when issue 7390 is fixed
  # https://github.com/gnuradio/gnuradio/issues/7390

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBoost_ATOMIC_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_atomic-mt.dll" \
      -DBoost_CHRONO_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_chrono-mt.dll" \
      -DBoost_DATE_TIME_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_date_time-mt.dll" \
      -DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_program_options-mt.dll" \
      -DBoost_THREAD_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_thread-mt.dll" \
      -DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE="${MINGW_PREFIX}/bin/libboost_unit_test_framework-mt.dll" \
      -DENABLE_CTRLPORT_THRIFT=OFF \
      -S "${_realname}-${pkgver}" \
      -DMATHJAX2_JS_PATH="${MINGW_PREFIX}/share/mathjax2" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

check() {
  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target test || warning "Tests failed"
}

package() {

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  #install hook and script for setting global_blocks_path and examples_path in grc.conf
  hook_path=${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.hook
  cp "${srcdir}/gnuradio-blocks-and-examples-path.hook.in" "${hook_path}"
  sed -s "s|@MINGW_PACKAGE_PREFIX@|${MINGW_PACKAGE_PREFIX}|g" -i "${hook_path}"
  install -Dt "$pkgdir/usr/share/libalpm/hooks" -m644 "${hook_path}"

  script_path="${srcdir}/${MINGW_PACKAGE_PREFIX}-gnuradio-blocks-and-examples-path.script";
  cp "${srcdir}/gnuradio-blocks-and-examples-path.script.in" "${script_path}"
  sed -s "s|@MINGW_PREFIX@|${MINGW_PREFIX}|g" -i "${script_path}"
  install -Dt "$pkgdir/usr/share/libalpm/scripts" -m755 "${script_path}"
 
  #install licenses
  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
  install -Dm644 "${srcdir}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.txt"
}
